function [P,S,X_2]=DFSC(X,Ds,Ws,Dp,Wp,alpha,beta,lambda,p,NIter)
[m,n]=size(X);
U=eye(m);
S=eye(n);
P=eye(m);
for iter=1:NIter
    S=S.*(X'*X+alpha*S*Wp)./(X'*X*S+alpha*S*Dp+eps);
    P=P.*(beta*X*X'+alpha*P*Ws)./(beta*X*X'*P+alpha*P*Ds+lambda*U*P+eps);
    Pi = sqrt(sum(P.*P,2)+eps);
    d = 0.5./Pi;
    U = diag(d);
    obj(iter)=trace((X-X*S)*(X-X*S)')+beta*trace((X'-X'*P)*(X'-X'*P)')+alpha*(trace(S*(Dp-Wp)*S')+trace(P*(Ds-Ws)*P'))+lambda*sum(Pi);
    if iter>2
        if abs(obj(iter)-obj(iter-1))<0.01
            break
        end
    end
end 
score= sum(P.*P,2);
[res, idx] = sort(score,'descend');
X_2 = X (idx(1:p),:);
end